//*****"DISSOLUTION" POV-Ray Scene by NEWT
//*****(C)2004 Indulgent Studios


//      Requires LightsysIV macros by Jaime Vives Piqueres (www.ignorancia.org)
//      You must set correct path (default is C:\Backup\scenes\LightsysIV) and grant I/O access

#version 3.5;          

global_settings {
        ambient_light 0.0
        assumed_gamma 1.5
}    


//*****CAMERA

#declare dof  =1;  // camera blur switch
camera{
        location <0,11,-18>
        up 2.4*y
        right 2.4*image_width*x/image_height
        direction 5*z
        look_at <0,0,0>
        #if (dof)
                focal_point <0,0,0>
                aperture 0.2
                blur_samples 60
                variance 0
                confidence 0.99
        #end   
        rotate 6.4*y
}     


//*****INCLUDES 

#include "colors.inc"
#include "textures.inc"
#include "metals.inc"   

#include "lights.inc"   
#include "manipulator.inc"
#include "fbodies.inc" 
#include "cell.inc"  


//*****OBJECTS

#declare a = seed(1276543);   
#declare b = seed(12763); 
#declare c = seed(6543); 
#declare d = seed(127654);
#declare e = seed(12345);   
#declare f = seed(123);      
#declare g = seed(423);     
     
#declare iris=0; // thingies with arms
object { irisphere(a,b,c,d,e,f) scale 0.15 rotate <-0,20,18> translate <-4,0,2> }   
object { irisphere(a,b,c,d,e,f) scale 0.15 rotate <-40,-34,0> translate <8,-5,20> }    
object { irisphere(a,b,c,d,e,f) scale 0.15 rotate <24,-38,45> translate <-3.5,-10,9> }     

#declare iris=1; // withouth arms
object { irisphere(a,b,c,d,e,f) scale 0.15 rotate <-20,30,10> translate <3,-1,-0.5> } 
object { irisphere(a,b,c,d,e,f) scale 0.15 rotate <-50,-100,-23> translate <-2,-3,10> }  

// cells placed at random
#declare i=0;
#while (i<55)
        object { cell(0.1) scale (0.2+0.1*rand(g)) rotate <360*rand(g),360*rand(g),360*rand(g)> translate <(10-20*rand(g)),(-20*rand(g)),(20-30*rand(g))> }    
        #declare i=i+1;
#end        
