//*****"DISSOLUTION" POV-Ray Scene by NEWT
//*****(C)2004 Indulgent Studios

//*****Feel free to use and modify.

//*****FORGEIN BODIES*****



#macro irisphere(a,b,c,d,e,f)
union { 

        #declare j = array[7] {1,4,8,8,8,4,1} 
        
        //holes in body
        #declare holes =union {  
                #declare i = 1;
                #while (i < 8) 
                #declare k = 0;
                #while (k < (j[i-1]))
                        cylinder { 0*y, 15*y, 1.95 rotate 180/6*(i-1)*x  rotate (360/j[i-1]*(k)+22.5*i)*y }
                        #declare k = k+1;
                #end
                #declare i = i+1;
        #end  
        }           
             
        #declare nut = difference {
                union { cylinder { 0*x,1*x,0.5 }
                        sphere { 0,0.5 scale <0.2,1,1> translate 1*x }
                        sphere { 0,0.7 scale <0.1,1,1> translate 0.5*x }
                }
                box { <-1,-0.2,-0.2>,<2,0.2,0.2> } 
                box { <-1,-0.2,-0.2>,<2,0.2,0.2> rotate 45*x }                    
                texture {
                        pigment { rgb <0.4,0.5,0.6> }
                        finish { 
                                phong 2  
                                phong_size 200
                                ambient 0
                                reflection .4
                                metallic 
                                brilliance 5  
                        }  
                } 
        }
        
        //main sphere body shape with holes
        difference {
                sphere { 0, 10 }
                holes 
                    
                texture {    
                        pigment {
                                image_map {"metal1"
                                map_type 1
                                interpolate 4
                                } 
                        } 
                        finish { 
                                phong 1  
                                phong_size 200
                                ambient 0
                                reflection .4
                                metallic 
                                brilliance 5  
                                irid { 0.3 thickness 0.1 turbulence 0.5 }
                        }  
                        normal { 
                                bump_map {"linemapn"  
                                        map_type 1
                                        bump_size 7
                                        interpolate 4
                                } 
                        } 
                }  
                
                
        } 
        
        //robot hands placement
        #declare hands = union {  
                #declare l = 1;
                #while (l < 8) 
                #declare m = 0;
                         #while (m < (j[l-1]))  
                                union { #if (iris=1) // choose to show hands (1) or close hole with "iris" (0)
                                        object {  
                                                manipulator((110+30*(2*rand(a)-1)),(50+20*(2*rand(b)-1)),(30*(2*rand(c)-1)),(30*(2*rand(d)-1)),(20+30*(2*rand(e)-1))) 
                                                scale 6
                                                rotate rand(f)*360*y
                                                translate y*9.9
                                        } 
                                        #end
                                          
                                        torus { 1.95, 0.1 translate 9.9*y 
                                                texture { 
                                                        pigment { color rgb <0.5,0.5,0.55> }
                                                        finish {   
                                                                phong 1 
                                                                        phong_size 3
                                                                        ambient 0
                                                                        reflection .1
                                                                        metallic 
                                                                        brilliance 10
                                                        }
                                                }          
                                        } 
                                        
                                        #declare i=0;
                                        #while (i<9)
                                                object { nut rotate z*90 scale <0.5,0.5,0.5> translate <2.45,9.5,0> rotate y*i*45 }
                                                #declare i=i+1;
                                        #end  
                                        
                                        #if (iris=0) // choose to show hands (1) or close hole with "iris" (0)
                                        #declare i=0;
                                                #while (i<24)
                                                       sphere_sweep {          
                                                                 b_spline
                                                                6,   
                                                                <1.95,0,-0.3>,0.1
                                                                <1.9,0,0.1>,0.1
                                                                <1.3,0.5,0.2>,0.1       
                                                                <0.8,0.55,0.2>,0.05    
                                                                <0.3,0.6,0.0>,0.03 
                                                                <0.2,0.5,-0.1>,0.01 
                                                                tolerance 0.001
                                                                translate <0,9.7,0>       
                                                                rotate 15*y*i
                                                                
                                                                texture { 
                                                                        pigment { color rgb <0.5,0.5,0.55> }
                                                                        finish {   
                                                                                phong 1 
                                                                                        phong_size 3
                                                                                        ambient 0
                                                                                        reflection .1
                                                                                        metallic 
                                                                                        brilliance 10
                                                                        }
                                                        }          
                                                                        
                                                        }
                                                        #declare i=i+1;
                                                #end
                                        #end 
                                        
                                                      
                                            
                                        rotate 180/6*(l-1)*x  rotate (360/j[l-1]*(m)+22.5*l)*y
                                }
                                #declare m = m+1;
                        #end
                        #declare l = l+1;
                #end  
        } 
                    
        hands 
        
        // little spikes on sphere surface
        difference {
                union {
                        #declare i=0;
                        #while (i<300)  //1000
                                union { 
                                        #declare h=rand(a);
                                        cylinder { 10*y,(12-2*h)*y,0.03 } 
                                        sphere { 0,0.03 translate (12-2*h)*y } 
                                        sphere { 0,0.07 scale <1,5,1> translate 10*y }
                                        rotate <rand(b),rand(c),rand(e)>*360  
                                }                  
                        #declare i=i+1;
                        #end            
                }                                          
                    
                holes 
                
                texture { 
                        pigment { color rgb <0.4,0.4,0.4> }
                        finish {   
                                phong 1 
                                phong_size 3
                                ambient 0
                                reflection .1
                                metallic 
                                brilliance 10
                        }
                }   
        }          
        
}
#end           


                                   