//*****LIGHTSYS STUFF 

//      Requires LightsysIV macros by Jaime Vives Piqueres (www.ignorancia.org)
//      You must set correct path (default is C:\Backup\scenes\LightsysIV) and grant I/O access


#include "C:\Backup\scenes\LightsysIV\CIE.inc"
#declare ColSys=sRGB_ColSys;
CIE_ColorSystemWhitepoint(ColSys,Blackbody2Whitepoint(4000))
#include "C:\Backup\scenes\LightsysIV\rspd_jvp.inc"
#include "C:\Backup\scenes\LightsysIV\lightsys.inc"
#include "C:\Backup\scenes\LightsysIV\lightsys_constants.inc"
#include "C:\Backup\scenes\LightsysIV\lightsys_colors.inc"
#declare Lightsys_Brightness=6; 


//*****VISIBLE LIGHT OBJECTS    


#macro roundlite(power)
        sphere { 0,0.5
                material {
                        texture{
                                pigment { color rgbf 1 }
                                finish { diffuse 0 }
                        }
                        interior{
                                media {
                                        method 1
                                        emission power
                                        intervals 10
                                        samples 1,10
                                        confidence 0.9999
                                        variance 1/1000
                                }
                        }
                }
                hollow
                no_shadow
        }
#end

#macro squarelite(power)
box { -0.5,0.5
        material {
                texture {
                        pigment { color rgbf 1 }
                        finish { diffuse 0 }
                }
                interior {
                        media {
                                method 1
                                emission power
                                intervals 10
                                samples 1,10
                                confidence 0.9999
                                variance 1/1000
                        }
                }
        }
        hollow
        no_shadow
        }
#end    


union {
        Light(Cl_Incandescent_60w,400,<9,0,0>,<0,0,9>,0,0,1)
        object{ roundlite(Cl_Incandescent_60w) scale <2,3,2> }
        translate -174.5*z
        translate 98.3*y
        rotate 90*y 
}

union {
        Light(Cl_SI_D65,3000,<100,0,0>,<0,0,100>,0,0,1)
        object{ squarelite(Cl_SI_D65*2000) scale <100,0.1,100> translate 0.9*y }
        rotate -90*x
        translate -249*z
        translate 16*y
        rotate 271.3*y
}   


//*****ENVIRONMENT

box { -1,1
        hollow
        scale <250,125,300>
        pigment { color rgb ReflectiveSpectrum(RS_ConstrStone2) }
        translate 45*y
}

plane {  y,169.9
        hollow
        pigment{rgb ReflectiveSpectrum(RS_White_Paint_1)}
}

