//*****"DISSOLUTION" POV-Ray Scene by NEWT
//*****(C)2004 Indulgent Studios

//*****Feel free to use and modify.

//*****MANIPULATOR*****
//*****5 degrees of freedom robotic arm macro
//*****uparm, loarm - control joint angles
//*****jog, pitch, roll - control wrist angles

#macro manipulator(uparm,loarm,jog,pitch,roll)

// materials

#declare metal1 = texture { 
        pigment { rgb <0.4,0.5,0.5> }
        finish { Metal }  
} 

#declare metal2 = texture {     
        pigment { rgb <0.5,0.5,0.5> }
        finish { 
                phong 2  
                phong_size 200
                ambient 0
                reflection {0.2,0.4} 
                conserve_energy 
                metallic 
                brilliance 5  
        }  
}  

#declare whitepaint = texture {
        pigment { image_map { jpeg "scratch.jpg"  
                        map_type 1
                        interpolate 4 }
                           
        } 
        finish { Metal }
}                             

#declare plastic = texture {
        pigment { blue 0.1 green 0.1 red 0.1 }
        finish { 
                phong 1  
                phong_size 30
                ambient 0
                reflection {0.1,0.3} 
                conserve_energy 
        }
}  


// light assembly

#declare lights = union {
        union {
                cylinder { 0*x, 0.15*x, 0.02 }
                sphere { 0, 0.02 scale < 1, 1, 1 > }
                torus { 0.016, 0.004 scale < 1, 3, 1 > rotate 90*z translate 0.15*x }
                texture { whitepaint }
        }
        sphere { 0, 0.016 scale < 0.4, 1, 1 > translate 0.15*x
                texture {
                        pigment { rgb < 1, 0, 0 > }
                        finish { ambient 1 }
                }
        }
}                                         

// base

union { 
        difference {
                union {
                        cylinder { < 0, -0.07, 0 >, < 0, -0.28, 0 >, 0.3 }
                        sphere { 0, 0.3 scale < 1, 0.03, 1 > translate < 0, -0.07, 0 > }  
                }
                box { 0, 1 translate < 0.15, -0.5, -0.5 > }
                torus { 0.3, 0.05 scale < 1, 1.2, 1 > translate < 0, -0.18, 0 > }
                box { < -0.2, -0.15, -0.1 >, < 1, 0, 0.1 > }
                box { 0,1 rotate < 0, 45, 0 > translate < 0.10, -0.5, -0.3 > }  
                box { < 0, 0, 0 >, < 1, 1, -1 > rotate < 0, -45, 0 > translate < 0.10, -0.5, 0.3 > }
                sphere { 0, 0.5 scale 0.05 translate < 0.165, -0.24, -0.12 > }
                sphere { 0, 0.5 scale 0.05 translate < 0.165, -0.24, 0.12 > } 
                texture { whitepaint }
        }  

        cylinder { < 0, -0.1, -0.1 >, < 0, -0.1, 0.1 >, 0.03 
                texture { metal2 }
        }
   
        union {
                cylinder { < 0.15, -0.2, 0.05 >, < 0.22, -0.2, 0.05 >, 0.02 }
                cylinder { < 0.26, -1, 0.05 >, < 0.26, -0.24, 0.05 >, 0.02 }
                intersection {
                        torus { 0.04, 0.02 rotate 90*x translate < 0.22, -0.24, 0.05 > }
                        box { < 0.22, -0.24, -1 >, < 1, 1, 1 > }
                }      
                        texture { metal1 }
        }                          

        union {
                cylinder { < 0.15, -0.2, -0.05 >, < 0.22, -0.2, -0.05 >, 0.02 }
                cylinder { < 0.26, -1, -0.05 >, < 0.26, -0.24, -0.05 >, 0.02 }
                intersection {
                        torus { 0.04, 0.02 rotate 90*x translate < 0.22, -0.24, -0.05 > }
                        box { < 0.22, -0.24, -1 >, < 1, 1, 1 > }
                }      
                texture { metal1 }
        } 

 
// base joint
  
        union {
                difference {
                        intersection { 
                                box { 0, 1 rotate < 45, 0, 0 > }
                                sphere { 0, 0.5 scale < 0.07, 0.6, 0.6 > translate < 0.05, 0, 0 > }
                                box { < 0, -0.5, 0.15>, < 1, 5.0, 1 > }  
                        } 
                        cylinder { < -1, 0, 0.26 >, < 1, 0, 0.26 >, 0.015 scale < 1, 1/0.7, 1 > } 
                        cylinder { < -1, 0.095, 0.23 >, < 1, 0.095, 0.23 >, 0.015 scale < 1, 1/0.7, 1 > }
                        cylinder { < -1, -0.095, 0.23 >, < 1, -0.095, 0.23 >, 0.015 scale < 1, 1/0.7, 1 > }
                }
                 
                difference {                    
                        intersection { 
                                box { 0, 1 rotate < 225, 0, 0 > } 
                                sphere { 0, 0.5 scale < 0.07, 0.6, 0.6 > translate < 0.05, 0, 0 > }
                                box { < 0, -0.5, -0.15>, < 1, 5.0, -1 > }   
                        }      
                        cylinder { < -1, 0, -0.26 >, < 1, 0, -0.26 >, 0.015 scale < 1, 1/0.7, 1 > } 
                        cylinder { < -1, 0.095, -0.23 >, < 1, 0.095, -0.23 >, 0.015 scale < 1, 1/0.7, 1 > }
                        cylinder { < -1, -0.095, -0.23 >, < 1, -0.095, -0.23 >, 0.015 scale < 1, 1/0.7, 1 > }
                }
                 
                difference {
                        intersection { 
                                sphere { 0, 1 scale < 0.2, 0.15, 0.10 > translate < 0, 0, 0.15 > }
                                box { 0, 1 translate < 0, -0.5, 0.15 > }    
                        }
                        cylinder { < 0.12, 0, 0.2 >, < 0.12, 0, 1 >, 0.032 scale < 1, 1/0.7, 1 >}
                }
                
                difference {                           
                        intersection { 
                                sphere { 0, 1 scale < 0.2, 0.15, 0.10 > translate < 0, 0, -0.15 > }
                                box { 0, 1 translate < 0, -0.5, -1.15 > }    
                        }
                        cylinder { < 0.12, 0, -1 >, < 0.12, 0, -0.2 >, 0.032 scale < 1, 1/0.7, 1 > }
                }
                 
                scale < 1, 0.7, 1 > 
                translate < -0.12, 0, 0 >
                rotate < 0, 0, 90 >
                texture { metal1 }
        }  

  
// upper arm 

        union {  
                cylinder { < 0, 0, -0.15 >, < 0, 0, 0.15 > , 0.025 texture { metal2 } }
            
                union {
                        superellipsoid { < 0.25, 0.25 > scale < 0.1, 0.03, 0.015 > }
                        cylinder { 0.015*z, 0.06*z, 0.035 translate < 0.075, 0, 0 >}    
                        translate < 0.075, 0, -0.04 >
                        rotate < 0, 0, (180-uparm+loarm) >
                        texture { metal2 }
                }   
                   
                union {
                        superellipsoid { < 0.25, 0.25 > scale < 0.28, 0.06, 0.035 > translate < 0.24, 0, 0.115 > }
                        superellipsoid { < 0.25, 0.25 > scale < 0.28, 0.06, 0.035 > translate < 0.24, 0, -0.115 > }
                        cylinder { < 0.52, 0, -0.15 >, < 0.52, 0, 0.15 >, 0.05 }
                        difference {
                                union { 
                                        sphere { 0, 1 scale < 0.05, 0.05, 0.01 > translate < 0.52, 0, -0.15 > }
                                        sphere { 0, 1 scale < 0.05, 0.05, 0.01 > translate < 0.52, 0, 0.15 > } 
                                }
                                cylinder { -1*z, 1*z, 0.01 translate 0.03*x rotate 0*z translate 0.52*x }
                                cylinder { -1*z, 1*z, 0.01 translate 0.03*x rotate 72*z translate 0.52*x }
                                cylinder { -1*z, 1*z, 0.01 translate 0.03*x rotate 144*z translate 0.52*x }
                                cylinder { -1*z, 1*z, 0.01 translate 0.03*x rotate 216*z translate 0.52*x }
                                cylinder { -1*z, 1*z, 0.01 translate 0.03*x rotate 288*z translate 0.52*x }
                        }           
                        texture { metal2 }
                }  

   
// lower arm 

                union {
                        union { 
                                difference {
                                        superellipsoid { < 0.25, 0.25 > scale < 0.2, 0.07, 0.075 > }
                                        box { < -1, -1, -0.04 >, < -0.05, 0.03, 0.04 > }
                                }     
                                
                                difference { 
                                        union {
                                                  box { < 0.18, -0.068, -0.08 >, < 0.35, 0.068, 0.08 > }
                                                  cylinder { < 0.18, 0, -0.08/0.5 >, < 0.35, 0, -0.08/0.5 >, 0.068 scale < 1, 1, 0.5 > } 
                                                  cylinder { < 0.18, 0, 0.08/0.5 >, < 0.35, 0, 0.08/0.5 >, 0.068 scale < 1, 1, 0.5 > }
                                                  cylinder { -0.08*z, 0.08*z, 0.068 scale < 2, 1, 1 > translate 0.35*x }
                                                  sphere { 0, 0.068 scale < 2, 1, 0.5 > translate < 0.35, 0, -0.08 > }
                                                  sphere { 0, 0.068 scale < 2, 1, 0.5 > translate < 0.35, 0, 0.08 > }
                          
                                        }
                                        cylinder { 0.18*x, 1*x, 0.03 scale < 1, 0.5, 1 > translate 0.068*y } 
                                }     
                                texture { whitepaint }        
                        }                
                
                        superellipsoid { < 0.2, 0.2 > scale < 0.025, 0.07, 0.12 > translate 0.18*x texture { plastic } }                           
                        
                        union {
                                cylinder { 0*x, 0.52*x, 0.035
                                        scale < 1, 1, 0.5 >
                                        rotate < 0, 0, (180+uparm-loarm) >
                                        translate < -0.15, 0, 0.0 >
                                }
                                cylinder { -0.05*z, 0.05*z, 0.035 translate < -0.15, 0, 0 > }
                                texture { metal1 }
                        } 
                        
                        union {
                                cylinder { 0.23*x, 0.55*x, 0.035 }
                                sphere { < 0.23, 0, 0 > 0.035 }
                                sphere { < 0.55, 0, 0 > 0.035 }
                                texture { metal2 }
                        } 
                        
                        
                        object { lights scale < 1, 2.2, 2.2 > translate < 0.28, -0.1, 0 > }                 
                        object { lights scale < 0.8, 1.5, 1.5 > translate < 0.28, -0.09, -0.065 > }    
                        object { lights scale < 0.8, 1.5, 1.5 > translate < 0.28, -0.09, 0.065 > } 
                        object { lights scale < 0.6, 1, 1 > translate < 0.27, -0.08, -0.11 > }      
                        object { lights scale < 0.6, 1, 1 > translate < 0.27, -0.08, 0.11 > }    
     
     
// grip
    
                #declare grip =    
                union { 
                        torus { 0.03, 0.01 rotate < 0, 0, 90 > translate < 0.03, 0, 0 > texture { plastic } }
                             
                        union { 
                                sphere { 0, 0.06 scale < 0.3, 1, 1 > translate < 0.05, 0, 0 > }  
                                cylinder { 0.05*x, 0.15*x, 0.06 }
                                      sphere { 0, 0.06 scale < 0.3, 1, 1 > translate < 0.15, 0, 0 > }
                                      sphere { 0, 0.04 scale < 1, 0.2, 0.15 > translate < 0.1, 0.06, 0 > rotate 30*x } 
                                      sphere { 0, 0.04 scale < 1, 0.2, 0.15 > translate < 0.1, 0.06, 0 > rotate 60*x } 
                                      sphere { 0, 0.04 scale < 1, 0.2, 0.15 > translate < 0.1, 0.06, 0 > rotate 90*x } 
                                      sphere { 0, 0.04 scale < 1, 0.2, 0.15 > translate < 0.1, 0.06, 0 > rotate 120*x } 
                                      sphere { 0, 0.04 scale < 1, 0.2, 0.15 > translate < 0.1, 0.06, 0 > rotate 150*x } 
                                      sphere { 0, 0.04 scale < 1, 0.2, 0.15 > translate < 0.1, 0.06, 0 > rotate 180*x } 
                                      sphere { 0, 0.04 scale < 1, 0.2, 0.15 > translate < 0.1, 0.06, 0 > rotate 210*x } 
                                      sphere { 0, 0.04 scale < 1, 0.2, 0.15 > translate < 0.1, 0.06, 0 > rotate 240*x } 
                                      sphere { 0, 0.04 scale < 1, 0.2, 0.15 > translate < 0.1, 0.06, 0 > rotate 270*x }
                                      sphere { 0, 0.04 scale < 1, 0.2, 0.15 > translate < 0.1, 0.06, 0 > rotate 300*x } 
                                      sphere { 0, 0.04 scale < 1, 0.2, 0.15 > translate < 0.1, 0.06, 0 > rotate 330*x }
                                      sphere { 0, 0.04 scale < 1, 0.2, 0.15 > translate < 0.1, 0.06, 0 > rotate 0*x }                          
                                      texture { metal1 }
                        } 
                   
                        #declare finger =
                                union { 
                                        superellipsoid { < 0.2, 0.2 > scale < 0.05, 0.025, 0.02 > rotate -80*y translate < 0.18,0,0.05 >  
                                                texture { whitepaint } }       
                                        union {
                                                intersection {
                                                        sphere { 0, 1 scale < 0.15, 0.02, 0.03 > }
                                                        box { < 0, -1, 0 >, < 1, 1, 1 > }
                                                        texture { metal1 }  
                                                }
                                                sphere { 0, 1 scale < 0.009, 0.009, 0.005 > translate 0.12*x texture { plastic } }
                                                sphere { 0, 1 scale < 0.012, 0.012, 0.005 > translate 0.09*x texture { plastic } }
                                                sphere { 0, 1 scale < 0.015, 0.015, 0.005 > translate 0.05*x texture { plastic } }   
                                                rotate -55*y
                                                translate < 0.2, 0, 0.07 >
                                        }   
                                } 
                   
                        #declare sw = rand (e);   
                        #if (sw <= 0.5) // choose to use hand  
                                object { finger scale 1.3 translate <-0.035,0,0> rotate 90*x }   
                                object { finger scale 1.3 translate <-0.035,0,0> rotate 210*x }
                                object { finger scale 1.3 translate <-0.035,0,0> rotate -30*x }  
                                sphere { 0, 0.055 scale < 1.5, 1, 1 > translate 0.17*x 
                                        texture { plastic }
                                }   
                        #end    
                           
                        
                           
                        #if (sw > 0.5) // choose to use transparent "probe" 
                                difference { 
                                        sphere { 0,0.03 scale <20,1,1> translate 0.*x }
                                        union { 
                                                sphere { 0,0.027 scale <20,1,1> translate 0.*x }
                                                cylinder { -1*x,1*x,0.01 }
                                                box { -1,<0,1,1> }
                                        }
                                        translate 0.15*x
                                        texture { pigment { Clear }
                                                finish {
                                                        reflection {0.1,0.3} 
                                                        conserve_energy 
                                                        ambient 0 diffuse 0  
                                                        specular 0.6 roughness 1/1000
                                                }                                        
                                        }     
                                        interior{ior 1.5}
                                } 
                                union { 
                                        cylinder { 0.15*x, 0.2*x, 0.04 }
                                        sphere { 0, 0.04 scale < 0.2, 1, 1 > translate 0.2*x } 
                                        texture { plastic }
                                }   
                        #end
                                
                }      
      
                object { grip scale 1.2 rotate < jog, 0, 0 > rotate < 0, pitch, 0 > rotate < 0, 0, roll > translate < 0.55, 0, 0 > }       
                            
                rotate < 0, 0, (-uparm+loarm) >
                translate < 0.52, 0, 0 >    
        }
        rotate < 0, 0, uparm >
        } 
        translate < 0, 0.28, 0 >
}        
#end